!= Module BasicEnvInit
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: initialdata_takemi2007.f90,v 1.2 2011-06-14 02:14:22 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
module initialdata_takemi2007
  !
  !ǥեȤδܾꤹ뤿Υ֥롼. 
  !ܾ׻, BasicSet ⥸塼ͤ. 
  !
  !ѥν꤫, ܾ(hogeBasicZ ѿ)
  !׻ʬBasicSet ⥸塼뤫ڤΥƤ. 
  !ECCM Ϥ, BasicSet Τ˰¸뤬 hogeBasicZ  use ʤ
  !֥롼Ѥ뤿Ǥ. 
  !

  !⥸塼ɤ߹
  use dc_types,   only: STRING, DP
  use dc_message, only: MessageNotify
  use gridset,  only: DimXMin,       &! X β
    &                 DimXMax,       &! X ξ
    &                 DimZMin,       &! Z β
    &                 DimZMax,       &! Z ξ
    &                 RegZMin,       &! Z β
    &                 RegZMax,       &! Z ξ
    &                 SpcNum,        &!Žʬο
    &                 z_Z,           &!顼ʻǤι
    &                 DelZ            !Z γʻֳ
  use basicset, only: BasicSetArray_Init, &!
    &                 PressBasis,    &!̤δవ
    &                 GasRDry,       &!ʬ갵Ǯ
    &                 CpDry,         &!ʬ갵Ǯ
    &                 CvDry,         &!ʬǮ
    &                 MolWtDry,      &!ʬʬ
    &                 SpcWetMolFr,   &!Žʬν
    &                 MolWtWet,      &!Žʬʬ
    &                 Grav,          &!ϲ®
    &                 Tropopause,    &!ή̹
    &                 TempSfc,       &!ɽ̲
    &                 PressSfc,      &!ɽ̰
    &                 GasRUniv        !
  use chemcalc, only: SvapPress       !
 
  !ۤηػ
  implicit none

  !ǥեȤ private
  private

  !
  public  initialdata_takemi2007_basic
  public  initialdata_takemi2007_wind

contains

!!!------------------------------------------------------------------------------!!!
  subroutine initialdata_takemi2007_nml

    initialdata_takemi2007_hum = 
    initialdata_takemi2007_  = "midlat"
    initialdata_takemi2007_  = "tropic"
    QMix = 

    ID = 6

  end subroutine initialdata_takemi2007_nml




  subroutine HUM_Takemi2007(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"BASE CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !
    implicit none
    
    real(DP),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(DP),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k
    
    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! z_Z  礦 12 km ʤ 12 km ή
      if (z_Z(k).eq.12000) then
        Ztr = z_Z(k)
        
      ! z_Z 礦12kmǤϤʤä,12kmľz_ZήZtrˤʤ
      else if (z_Z(k).gt.12000) then
        Ztr = minval( z_Z, 1, z_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = z_Z(TR))
    do k = RegZMin+1,DimZMax
      if (z_Z(k).ge.12000.and.z_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do
    
    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (z_Z(k).le.1500.and.z_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do
    
    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmʲμ٤ϥˤƤ
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      else if (k.le.TR.and.k.gt.LL) then
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25

      else if (k.gt.TR) then
        z_RH(k) = 0.25
      end if
    end do
  end subroutine HUM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_TDRY(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"DRY CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !     * پȤϴΤ㤦
    !

    implicit none

    real(DP),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(DP),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax
      
      ! z_Z  礦 12 km ʤ 12 km ή
      if (z_Z(k).eq.12000) then
        Ztr = z_Z(k)

      ! z_Z 礦12kmǤϤʤä,12kmľz_ZήZtrˤʤ
      else if (z_Z(k).gt.12000) then
        Ztr = minval( z_Z, 1, z_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = z_Z(TR))
    do k = RegZMin+1,DimZMax
      if (z_Z(k).ge.12000.and.z_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (z_Z(k).le.1500.and.z_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do

    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmʲμ٤ϥˤƤ
    ! , 絤Υȥ쥤ȤθǮӤ"DRY CASE"Ǥ
    !  2.5 km, 5.0 km, 7.5 km Τɤм٤ 20 % 餹DRY1,2,3Ѱդ
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      ! 1.5 km  (2.5 km, 5.0 km, 7.5 km) ޤǤϤΤޤѲ

!     else if (z_Z(k).lt.2500.and.k.gt.LL) then   ! DRY1
!     else if (z_Z(k).lt.5000.and.k.gt.LL) then   ! DRY2
      else if (z_Z(k).lt.7500.and.k.gt.LL) then   ! DRY3
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25

      ! (2.5 km, 5.0 km, 7.5 km)20 % ٤򸺾 
!     else if (z_Z(k).ge.2500) then   ! DRY1
!     else if (z_Z(k).ge.5000) then   ! DRY2
      else if (z_Z(k).ge.7500) then   ! DRY3
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25 - 0.20d0

      end if
    end do

    ! м٤ 25% ʲˤʤ 25% Ǹꤹ
    do k = RegZMin+1, DimZMax
      if (z_RH(k).le.(0.25).and.k.gt.LL) then
        z_RH(k) = 0.250d0
      end if
    end do

  end subroutine HUM_Takemi2007_TDRY

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_MDRY(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"DRY CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !     * ǮӾȤϴΤ㤦

    implicit none

    real(DP),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(DP),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! z_Z  礦 12 km ʤ 12 km ή
      if (z_Z(k).eq.12000) then
        Ztr = z_Z(k)

      ! z_Z 礦12kmǤϤʤä,12kmľz_ZήZtrˤʤ
      else if (z_Z(k).gt.12000) then
        Ztr = minval( z_Z, 1, z_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = z_Z(TR))
    do k = RegZMin+1,DimZMax
      if (z_Z(k).ge.12000.and.z_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (z_Z(k).le.1500.and.z_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do


    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmޤǤμ٤ϥˤƤ
    ! 絤Υȥ쥤Ȥθپ"DRY CASE"Ǥ
    !  2.5 km м٤ 13 % ⤷ 30 % 餹 DRY1,2 Ѱդ.
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      ! 1.5 km 2.5 km ޤǤϤΤޤѲ
      else if (z_Z(k).lt.2500.and.k.gt.LL) then
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25

      ! 2.5 km ʹߤ 13 % or 30 % 餹
      else if (z_Z(k).ge.2500) then
!       z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25 - 0.13d0   ! DRY1
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25 - 0.30d0   ! DRY2

      end if
    end do

    ! м٤ 25% ʲˤʤ 25% Ǹꤹ
    do k = RegZMin+1, DimZMax
      if (z_RH(k).le.(0.25).and.k.gt.LL) then
        z_RH(k) = 0.250d0
      end if
    end do

  end subroutine HUM_Takemi2007_MDRY


!!!------------------------------------------------------------------------------!!!
  subroutine  initialdata_takemi2007_basic( z_Temp, z_Press, za_MolFr )
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * ܾβ٤μ̤ͿƤ뤿, ٤Ѵɬפ
    !
    
    implicit none

    real(DP), intent(out):: z_Press(DimZMin:DimZMax)!
    real(DP), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(DP), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) !
    !
    ! ECCM_TakemiǤΤɬפѿ
    !
    real(DP) :: z_TakemiRH(DimZMin:DimZMax)         ! 1.5km ʾм
    real(DP) :: z_TakemiTheta(DimZMin:DimZMax)      !ܾβ
    real(DP) :: Theta_0                             ! ɽ̤β
    real(DP) :: Theta_tr                            ! ή̤β
    real(DP) :: TakemiZtr                           ! ή̤ι
    real(DP) :: HumSfc                              ! ɽ̤м
    real(DP) :: a_MolFrSfc                          ! ɽ̤Υ
    real(DP) :: z_LLhumidity(DimZMin:DimZMax)       ! 1.5 km ޤǤм
    !!--------------------------------------------------
    integer             :: k, s, i, m, b, T, L

    z_TakemiRH = 0.0d0
    z_TakemiTheta = 0.0d0

    ! پ
    select case (initialdata_takemi2007_hum)
    case (ID_initialdata_takemi2007_hum)
      call HUM_Takemi2007(z_TakemiRH,TakemiZtr,T,L)
    case (ID_initialdata_takemi2007_TDRY)
      call HUM_Takemi2007_TDRY(z_TakemiRH,TakemiZtr,T,L)
    case (ID_initialdata_takemi2007_MDRY)
      call HUM_Takemi2007_MDRY(z_TakemiRH,TakemiZtr,T,L)
    end select

    ! ١١

    !ɽ̤β̤300K
    Theta_0 = 300.0d0

    ! پǮӾ
    ! ή̤β̤Ƕ̤Ƥ
    select case (initialdata_takemi2007_*)
    case (ID_initialdata_takemi2007_midlat)
      Theta_tr = 343.0d0     ! 
    case (ID_initialdata_takemi2007_tropic)
      Theta_tr = 358.0d0     ! Ǯ
    end select

    ! 絤ǲؤβ
    z_TakemiTheta(RegZMin+1) = &
      & Theta_0 + (Theta_tr - Theta_0)*(z_Z(RegZMin+1) / TakemiZtr)**1.25

    z_Temp  = 1.0d-60
    z_Press = 1.0d-60
    z_LLhumidity = 0.0d0

    ! 絤ǲؤε桦ʬ̤η׻

    ! ɽ̤Υ
    ! 10g/kg18g/kgκͿƤ뤿ľ
    ! ʤǮӾQ18Τ߻
    a_MolFrSfc = Qb * MolWtDry / MolWtWet(1)  
!   a_MolFrSfc = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!   a_MolFrSfc = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
!   a_MolFrSfc = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!   a_MolFrSfc = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!   a_MolFrSfc = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10 

    ! ɽ̤м
    ! 椫ջ. Τɬ
    HumSfc = a_MolFrSfc * PressSfc / SvapPress(6,TempSfc)

    ! 絤ǲؤε
    z_Press(RegZMin+1) = &
           & PressSfc - (Grav * PressSfc * DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + a_MolFrSfc * (MolWtWet(1) - MolWtDry))) &
           & *TempSfc)

    ! 絤ǲؤβ.̤򸵤˷׻
    ! ɽ̵ 1000hPa Ȳꤹ
    z_Temp(RegZMin+1) = z_TakemiTheta(RegZMin+1) &
                        &* (z_Press(RegZMin+1) / 100000.0d0)**(GasRDry / CpDry)

    ! 絤ǲؤΥ
    ! ǮӾQ18Τ߻
    za_MolFr(RegZMin+1,1) = Qb * MolWtDry / MolWtWet(1) 
!    za_MolFr(RegZMin+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!   za_MolFr(RegZMin+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
!   za_MolFr(RegZMin+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!   za_MolFr(RegZMin+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!   za_MolFr(RegZMin+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10
 
    ! 絤ǲؤм
    ! 椫ջ. Τɬ
    z_LLhumidity(RegZMin+1) = &
      & za_MolFr(RegZMin+1,1) * z_Press(RegZMin+1) / SvapPress(6,z_Temp(RegZMin+1))

    ! 絤ǲؤμʪ̤Ȥ˲١ٵδܾ
    !  0 - 1.5km  1.5km - Ǽ٤Ϳۤʤ,
    ! , ή̰ʾǤϲ٤μۤʤΤ, ʲ 3ѥʬ
    ! ܾ
    !  0 - 1.5km, 1.5km - ή(Ztr), Ztrʾ 
    do k = RegZMin+1, DimZMax

    !
    ! ܾ(I)
    ! 絤ǲؤ 1.5 km ʲ(k  L-1 ʲ)δܾ
    !
     if (k.le.L-1) then

      ! 
      !  1.5km ޤǤϥ椬ǤդͤǸꤵƤ
      ! , ǮӾ 18 g/kg Τ
      za_MolFr(k+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)
 
      ! 
      z_Press(k+1) = &
           & z_Press(k)-(Grav*z_Press(k)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k))

      ! ̤鲹٤׻
      z_TakemiTheta(k+1) = Theta_0 + (Theta_tr - Theta_0)*(z_Z(k+1) / TakemiZtr)**1.25
      z_Temp(k+1) = z_TakemiTheta(k+1) * (z_Press(k+1) / 100000.0d0)**(GasRDry / CpDry)

      ! 椫м٤׻
      z_LLhumidity(k+1) = za_MolFr(k+1,1) * z_Press(k+1) / SvapPress(6,z_Temp(k+1))

      !
      !== Takemi(2007)δܾλѾ
      !  * ؤǺꤷ³ȹ 1.5km ޤǤм٤100%Ķ٤
      !  * 100% ĶƤޤä٤μ٤, ľι٤μ٤ˤ
      !    Takemi(2007)Ʊ٤αľץե뤬
      !    * ʤ
      !  * MQ16   99.% ȤͤФ, 100% ĶʤƤۤ100%
      !    ͤФƤޤ
      !    * Takemi(2007)ǤϤΤ褦ͤ褦ˤϸʤ
      !      礦ʤΤMQ18 MQ14  100% Ķľͤδ֤äͤƤ
      !      * 0.94511507230d0Ȥ嵭
      if (z_LLhumidity(k+1).gt.1) then
        z_LLhumidity(k+1) = z_LLhumidity(k)
!     if (z_LLhumidity(k+1).gt.0.99) then      !MQ16 
!       z_LLhumidity(k+1) = 0.94511507230d0    !MQ16 
     end if

     !
     ! ܾ(II)
     !  1.5km , ή̰ʲ(L < k < T)δܾ
     !
     else if (k.le.T.and.k.gt.L) then

      ! k = L Ǥм
      !  if ʸν k  L+1 Ϥޤ z_TakemiRH(L) ֳʤΤͤͿ
      z_TakemiRH(L) = z_LLhumidity(L)

      ! δܾ
      z_Press(k) = &
           & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k+1,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k-1))

       ! ̤鲹٤׻
       z_TakemiTheta(k) = Theta_0 + (Theta_tr - Theta_0)*(z_Z(k) / TakemiZtr)**1.25
       z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

       ! 絤ʿʬ
       za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)
     
       !
       ! ܾ(III)
       ! ή̤ (k > T) ξ
       !
       else if (k.gt.T) then

       ! δܾ
       z_Press(k) = &
           & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k-1))

       ! ̤鲹٤׻
       z_TakemiTheta(k) = Theta_tr * exp(Grav * (z_Z(k) - TakemiZtr) / (CpDry * z_Temp(T)))
       z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

       ! 絤ʿʬ
       za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)

     end if
    end do

  end subroutine Initialdata_takemi2007_basic


  subroutine initialdata_takemi2007_wind

    !-------------------------------------------------------------!
    !  (Takemi,2007)                                  !
    !-------------------------------------------------------------!
    !
    != 
    !* case "Takemi2007" Ǥη׻˱ľΤͿ˻Ѥ
    !* Ϳˤ, ʲΤ褦ʥХꥨ󤬤
    !  (1) Ϳ٤Ѥ
    !  (2) Τκ® (U_s) Ѥ
    !
    !  (1) ˤĤƤ, (a) 0 - 2.5 km, (b) 2.5 - 5.0 km, (c) 5.0 - 7.5 km 
    !  ѥ󤬤
    !  (2) ˤĤƤ, Takemi (2007) ǤǮӾپβپ
    !  ۤʤͤꤷƤ
    !
    !  ζ(Us), ʲ̤
    !  <ǮӾ>   (1) 5 m/s, (2) 10 m/s, (3) 15 m/s
    !  <پ> (1) 10 m/s, (2) 15 m/s, (3) 20 m/s
    !
    !* ηϼ (Takemi, 2007)   |
    !                                     /| 7.5 km
    !                                    / |
    !                                   /  |
    !                                  / |
    !                                   /| 5.0 km
    !                                  / |
    !                                 /  |
    !                                  / |
    !                                   /| 2.5 km
    !                                  / |
    !                                 /  |
    !                                  / |
    !---------------------------------+------------- 0.0 km
    !                                Us (m/s)
    !
    
    ! Ϳ٤
    ! Ϥι٤γʻ (B)  νγʻ (U) Ƿ
    
    do k = RegZMin+1, DimZMax
      if (s_Z(k).ge.Hb.and.s_Z(k).le.(Hb + DelZ)) then
        B = k
      end if
      
      if (s_Z(k).ge.Hu.and.s_Z(k).le.(Hu + DelZ)) then
        U = k
      end if
    end do
    
    ! 嵭Ƿ᤿ʻBUδ֤˱ľΤͿ
    
    do k = RegZMin+1, U
      do i = DimXMin, DimXMax
        if (k.lt.B) then
          pz_VelX(i,k) = - Us
        else
          pz_VelX(i,k) = - Us + (Us / (s_Z(U) - s_Z(B))) * (s_Z(k) - s_Z(B))
        end if
      end do
    end do
    
  end subroutine initialdata_takemi2007_wind
  
end module initialdata_takemi2007
